function approx = bel(d,ne,G,f) %Union of ELlipsoids
    
    nxu = size(G,2);
    evec = reshape(d,ne,[]);
    ellipses = zeros(ne,length(f));
        
    for i=1:ne        
        vec = evec(i,1:end-nxu);
        s0 = evec(i,end-nxu+1:end);
        Q = diag(vec(1:nxu))+squareform(vec(nxu+1:end));
        Omega = 0.5.*Q'*Q;
        for j=1:length(f)
            ellipses(i,j) = (G(j,:)-s0)*Omega*(G(j,:)-s0)';
        end
    end
      
    approx = min(ellipses,[],1);
    
end

