function approx = const_approx(S,params)

    rng('shuffle');
    
    tic;
    
    const = params.constfunc(S(:,params.nx+1:end)',S(:,1:params.nx)');
    
    if strcmp(params.subregions,'ellipsoid')
        N = (params.nx+params.nu).*(params.nx+params.nu+3)./2.*params.ne; 
        nd = params.ne;
        rmin = max((([params.ubxm',params.ubum']-...
            [params.lbxm',params.lbum'])./2).^(-2));
        lb = repmat([-rmin.*ones(1,...
            (params.nx+params.nu).*(params.nx+params.nu+1)./2),...
            params.lbxm',params.lbum'],params.ne,1);
        ub = repmat([rmin.*ones(1,...
            (params.nx+params.nu).*(params.nx+params.nu+1)./2),...
            params.ubxm',params.ubum'],params.ne,1);
        pool = rand(params.ns,N)*diag(ub(:)-lb(:))+lb(:)';
    else
        N = (params.nx+params.nu+1).*(sum(params.id_reg)); 
        nd = params.id_reg;
        lb = [];
        ub = [];
        pool = 20.*rand(params.ns,N)-10;
    end
     
    J = Inf(params.ns,1);
    Solutions = zeros(params.ns,N);
    flag = -ones(params.ns,1);      
    
    if strcmp(params.capproach,'region-based') % ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~  
        NL = const<=1;
        options = params.pswopts;
        options.SwarmSize = 10.*N;              
        % optimization problem ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~            
        for c=1:params.ns        
            try
                [Solutions(c,:), J(c)] = ...
                    particleswarm(@(d) ...
                    misclass(d,nd,S,NL,params.regfunc,params.gamma),...
                    N,lb(:),ub(:),options);
            catch ME
                % nothing
            end        
        end
    else % ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~ ~ . ~       
        NL = const;     
        % optimization problem ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~     
        for c=1:params.ns        
            try
                [Solutions(c,:),J(c),~,flag(c),~] = ...
                    lsqnonlin(@(dv) err_vec(dv,nd,S,NL,params.regfunc),...
                    pool(c,:),lb(:),ub(:),params.lsqopts);
            catch ME
                % nothing
            end         
        end
    end

	% Best solution ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~

    [approx.obj, idx] = min(J);
    approx.OptSol = Solutions(idx,:);
    approx.eltime = toc;
 

end
