function xdot = dyn_cv(u,x) % gives Fx and Fy
    
    delta = u;
    r = x(1);
    beta = x(2);
    
%     delta = u(1,:)';
%     r = x(1,:)';
%     beta = x(2,:)';
    
    % TIRE PARAMETERS - - - - - - - - - - - - - - - - - - - - - - - - 
    
    Da = 1.0;       Ca = 1.6;       
    Ba = 10.0;      Ea = 0.0; 
    lf = 1.35;      lr = 1.15;
    Izz = 1300;     mu = 1;  
    Fmax = 5000;    vx = 15;
    m = 1725;
    
    % FUNCTION STARTS HERE - - - - - - - - - - - - - - - - - - - - - - - - 
   
    alphaf = atan(beta + lf.*r./vx) - delta;
    alphar = atan(beta - lr.*r./vx);
    
    Fyf = Fmax.*mu.*Da.*sin(Ca.*atan(Ba.*alphaf));
    Fyr = Fmax.*mu.*Da.*sin(Ca.*atan(Ba.*alphar));
    
    rdot = (lf.*Fyf - lr.*Fyr)./Izz;
    betadot = atan((Fyf+Fyr)./m./vx-r);
    
    xdot = [rdot(:),betadot(:)]';
end
